VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsArrayUtils"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Class Array Utilites:
'By: Joel Dooris
'Email JoelDooris@hotmail.com
'This class is a set of methods that work on arrays that are in
'the format made by a recordset.getrows call. This format is a two dimentional
'Array with the first being the number of fields and the second being the number
'of records.

Public Function AreAnyOfTheseInThis(ByRef These() As Variant, ByRef This() As Variant, Optional IgnoreTheseFields As Variant) As Integer
    '
    'Get an array that is in the same format as a call to recordset.getrows
    '(Frist Dimention is the number of fields, second is the number of records)
    'the Array THESE is the Master Record
    'The Array THIS is the subordinate records
    'Function will itterate through the master records one record at a time. It will then
    'compare the current record with each of the subordinate records. If a match is found
    'a flag is thrown and the record number of the MASTER record is returned. If no matches
    'are found then it returns a -1.
    'The optional variable is an array of field indexes to skip. That means the These
    'array can be larger than the This array.
    '
    Dim intTheseRecordNdx           As Integer  'Loop index for each record in THESE
    Dim intThisRecordNdx            As Integer  'Loop index for each record in THIS
    Dim intFieldNdx                 As Integer  'Loop index for each Field in the records
    Dim intThisRecordCount          As Integer  'The number of records in the THIS Array
    Dim intTheseRecordCount         As Integer  'The number of Records in the THESE Array
    Dim intThisFieldCount           As Integer  'The Number of fields in the Array THIS
    Dim intTheseFieldCount          As Integer  'The Number of fileds in the Array THESE
    Dim blnMatch                    As Boolean  'A flag to tell us that a match exist on the field level check
    Dim intRowMAtch                 As Integer  'The MASTER records Row Number that was found
    Dim intIgnoreNdx                As Integer  'This is the loop index for the Ignore Fields loop
    Dim intIgnoreCount              As Integer  'This is the total number of fields to ignore
    Dim blnIgnore                   As Integer  'This is a flag to tell us to ignore this field
    On Error GoTo ErrorHandler
    '
    ' First things First, lets check out what was passed and make sure both Arrays are valid!
    '
    If Not IsRealArray(This) Or Not IsRealArray(These) Then
        Err.Raise -1234, "", "This and/or These are not a real arrays!"
    End If
    '
    ' Now get the sized of what was passed
    '
    intTheseFieldCount = UBound(These, 1)   '
    intThisFieldCount = UBound(This, 1)     'Get Field Sizes
            
    intThisRecordCount = UBound(This, 2)
    intTheseRecordCount = UBound(These, 2)  'Get Record Counts
    If Not IsMissing(IgnoreTheseFields) Then
        'We need to subtract out the count of these fields to get an acruate number.
        intIgnoreCount = UBound(IgnoreTheseFields) + 1
        intTheseFieldCount = intTheseFieldCount - intIgnoreCount
    End If
    '
    'Now just verify the two arrays have the same amount of fields
    '
    If intThisFieldCount <> intTheseFieldCount And intThisFieldCount < intTheseFieldCount Then
        Err.Raise -1234, "", "Number of fields in These <> the number of fields in THIS. So I tanked!"
    End If
    '
    ' Ok, The logic here is as follows: Itterate through the master recordset down to the field level.
    ' Compair the current Master records fields to each subordinate records same position field.
    ' If you get a match throw the field level flag, and keep track of the current master record.
    ' Check all of the remainding fields, if any of them do not match then exit the field level
    ' loop and move to the next subordinate record. If they do match then we have what we are looking for
    ' so pass the user the Record ID of the matching master record.
    '
    For intTheseRecordNdx = 0 To intTheseRecordCount
        For intThisRecordNdx = 0 To intThisRecordCount '
            For intFieldNdx = 0 To intTheseFieldCount
                If ignorecount <> 0 Then
                    For intIgnoreNdx = 0 To intIgnoreCount
                        If IgnoreTheseFields(intIgnoreNdx) <> intFieldNdx Then
                            'This is not the field we are to ignore, so process it
                        Else
                            'This is the Field to ignore, no sence in further processing
                            blnIgnore = True
                            Exit For 'Harsh! But it is needed for speed. Exit the ignore loop
                        End If
                    Next intIgnoreNdx
                End If 'End the ignore check
                If Not blnIgnore Then 'This should remain false if no ignore options are passed
                    'This field is to be processed
                    If These(intFieldNdx, intTheseRecordNdx) = _
                       This(intFieldNdx, intThisRecordNdx) _
                    Then 'These two cells match so Flag it as a possible record match
                            blnMatch = True
                            intRowMAtch = intTheseRecordNdx
                    Else
                        'If we get in here then all of the fields do not match, so flag it as such
                            blnMatch = False
                            intRowMAtch = 0
                            Exit For 'Don't check any more, if any one of the fields fail then this record does not match. Get the next one!
                    End If
                Else 'Ignore this field
                End If  'End the ignore field check
                blnIgnore = False 'Reset it for the next check
            Next intFieldNdx
            '
            'We just went through all of the fields in the THIS array.
            'If we have a match then we need to tell the user and bail.
            '
            If blnMatch Then
                AreAnyOfTheseInThis = intRowMAtch
                Exit Function
            End If
        Next intThisRecordNdx 'Go on to the next record because the fields do not match
    Next intTheseRecordNdx 'Check the next MASTER Record against all of the subordinate records
    '
    'If we get here we have searched through both arrays records and there were no matches.
    'Lets tell the user by passing a zero back and then  bail!
    '
    AreAnyOfTheseInThis = -1
    Exit Function
ErrorHandler:
    Err.Raise Err.Number, "AreAnyOfTheseInThis", Err.Description
End Function
Public Function AreAnyOfTheseNOTInThis(ByRef These() As Variant, ByRef This() As Variant) As Integer
    '
    'Get an array that is in the same format as a call to recordset.getrows
    '(Frist Dimention is the number of fields, second is the number of records)
    'the Array THESE is the Master Record
    'The Array THIS is the subordinate records
    'Function will itterate through the master records one record at a time. It will then
    'compare the current record with each of the subordinate records. If no master record matchs exist
    'in the subordinate recordset a flag is thrown and the record number of the MASTER record is returned.
    'If All Fields match then it returns a -1.
    '

    Dim intThisRecordNdx        As Integer  'Loop index for each record in THIS
    Dim intTheseRecordNdx       As Integer  'Loop index for each record in THESE
    Dim intFieldLoopNdx         As Integer  'Loop index for each Field in the records
    Dim intThisRecordCount      As Integer  'The number of records in the THIS Array
    Dim intTheseRecordCount     As Integer  'The number of Records in the THESE Array
    Dim intThisFieldCount       As Integer  'The Number of fields in the Array THIS
    Dim intTheseFieldCount      As Integer  'The number of Records in the THESE Array
    Dim blnNoFieldMatch         As Boolean  'A flag to tell us that a match exist on the field level check
    Dim blnNoRecordMatch        As Boolean  'A flag to tell us that a match exist on the record level check
    Dim intNotFoundIndex        As Integer  'The MASTER records Row Number that was found
    '
    On Error GoTo ErrorHandler
    '
    ' First things first, verify the arrays passed are valid arrays
    '
    If Not IsRealArray(This) Or Not IsRealArray(These) Then
        Err.Raise -1234, "", "This and/or These are not a real arrays!"
    End If
    '
    ' Now get the sizes of what was passed
    '
    intTheseFieldCount = UBound(These, 1)       '
    intThisFieldCount = UBound(This, 1)         'The number of fields
    
    intThisRecordCount = UBound(This, 2)        '
    intTheseRecordCount = UBound(These, 2)      'The Number Of Records
    '
    'Verify that the two arrays have the same number of fields
    '
    If intThisFieldCount <> intTheseFieldCount Then
        Err.Raise -1234, "", "Number of fields in These <> the number of fields in THIS. So I tanked!"
        Exit Function
    End If
    '
    ' Ok, The logic here is as follows: Itterate through the master recordset down to the field level.
    ' Compair the current Master records fields to each subordinate records same position field.
    ' If you get a field match, keep looking at the rest of the fields. IF they all match then move to the
    ' next subordinate record. When we geta field that does not match, we need to flag that field and keep
    ' track of the master record number that did not match. We continue to scan the rest of the subordiante
    ' records looking for a match, if one is found reset all flegs and check the next Master records varaible.
    ' If a match is still not found then return the record Id and exit the function.
    For intTheseRecordNdx = 0 To intTheseRecordCount
        For intThisRecordNdx = 0 To intThisRecordCount
            For intFieldLoopNdx = 0 To intTheseFieldCount 'For Each Field in the suboridante list
                If These(intFieldLoopNdx, intTheseRecordNdx) <> _
                   This(intFieldLoopNdx, intThisRecordNdx) _
                Then 'These two cells dont match so bail!
                    blnNoFieldMatch = True
                    intNotFoundIndex = intTheseRecordNdx
                    Exit For 'Exit the Field for and go to the next THIS record
                End If
            Next intFieldLoopNdx
            If blnNoFieldMatch Then
                blnNoRecordMatch = True
            Else 'We found a match further down the list so this record is OK
                blnNoRecordMatch = False
                intNotFoundIndex = 0
                blnNoFieldMatch = False 'Reset this for the next itteration
                Exit For 'This record is ok so lets move out to the next THESE value
            End If
            blnNoFieldMatch = False 'Reset this for the next itteration
        Next intThisRecordNdx 'Check the next THIS Record For the Current THESE value
        
            'Ok if we get here and we got a flag telling us not found
            ' we have checked all of the THIS records and the THESE value was not found
            'We need to report that it was not found and exit the function.
            If blnNoRecordMatch Then
                AreAnyOfTheseNOTInThis = intNotFoundIndex
                Exit Function
            End If
        'Otherwise the value in THESE was found so lets look at the next one
        
    Next intTheseRecordNdx
    'We get here nothing was wrong so tell user
    AreAnyOfTheseNOTInThis = -1
    Exit Function
ErrorHandler:
    Err.Raise Err.Number, "AreAnyOfTheseNotInThis", Err.Description
End Function
Public Function RemoveRecord(ByRef PassedArray() As Variant, ByVal RemoveRecordNumber As Integer) As Boolean
    '
    'This Function will remove a record from the passed array based on the number passed it. The Array that is passed
    'is BYREF so THAT ARRAY is the one that is CHANGED!
    '
    Dim infFieldNdx     As Integer  'An index that keeps track of the current field
    Dim intRecordNdx    As Integer  'An index that keeps track of the current Record
    Dim aryTemp()       As Variant  'An array to hold the PassedArray's Keeper records
    Dim intNbrOfFields  As Integer  'Tells the number of fields in PassedArray
    Dim intNbrOfRows    As Integer  'Tells the Number of Rows in Passed Array
    '
    On Error GoTo ErrorHandler
    '
    ' First thing is to check to see if the array passed  is a good array
    '
    If Not IsRealArray(PassedArray) Then
        Err.Raise -1234, "", "The array Passed is not valid."
    End If
    '
    'Get Info from PassedArray
    '
    intNbrOfRows = UBound(PassedArray, 2)
    intNbrOfFields = UBound(PassedArray, 1)
    '
    ' Logic here is cycle through each record down to the field level. Check to verify that the current record
    ' is not the one to remove. If it is not then itterae through each field and copy its value to the temp
    ' array. If the curent record is the one to remove then do not copy this record and move on to the next.
    ' At the end of this all set the PassedArray = to the Temp Array.
    '
    For intRecordNdx = 0 To intNbrOfRows
        If intRecordNdx <> RemoveRecordNumber Then
            If Not IsRealArray(aryTemp) Then
                ReDim aryTemp(intNbrOfFields, 0)
            Else
                ReDim Preserve aryTemp(UBound(aryTemp, 1), UBound(aryTemp, 2) + 1)
            End If
            For infFieldNdx = 0 To intNbrOfFields
                aryTemp(infFieldNdx, UBound(aryTemp, 2)) = PassedArray(infFieldNdx, intRecordNdx)
            Next infFieldNdx
        End If
    Next intRecordNdx
    '
    ' Set up the return Values
    '
    PassedArray = aryTemp
    RemoveRecord = True
    
    Exit Function
ErrorHandler:
    Err.Raise Err.Number, "RemoveRecord", Err.Description

End Function
Public Function AddRecords(ByRef ArrayToAddTo() As Variant, ByRef RowsToAdd() As Variant, Optional AddRowIndex As Integer) As Boolean
'
' This Function is passed two arrays. It will take the RowsToAdd Array and Append it to the ArrayToAddTo Array.
'
    Dim intFields       As Integer      'The Number of Fields
    Dim intFieldNdx     As Integer      'The current field being updated
    Dim intRowNdx       As Integer      'The curent Row that is being updated
    Dim intRowsToAdd    As Integer      'Number of rows in the RowsToAdd Array
    '
    On Error GoTo ErrorHandler
    '
    ' Check to see that Rows To Add array is a real array. If it is not then tank!
    ' Array to add to can be blank so we will not check it here, we do check it further down though.
    '
    If Not IsRealArray(RowsToAdd) Then
        Err.Raise -1234, "", "RowsToAdd is not a valid array!"
    End If
    '
    ' Now get the dimentions of the array passed
    '
    intFields = UBound(RowsToAdd, 1)
    intRowsToAdd = UBound(RowsToAdd, 2)
    '
    'Logic: First check to see if the array to add to is a valid array. If it is add another row to it.
    'If it is not then add a row starting at element zero. Then Cycle through each record in
    'the array rows to add, down to the field level. Then copy each field to the newly created row
    'in the array to add to array. Return a true at the end of the operation.
    '
    For intRowNdx = 0 To intRowsToAdd
        If Not IsRealArray(ArrayToAddTo) Then 'This is our first time in this
            ReDim Preserve ArrayToAddTo(UBound(RowsToAdd, 1), 0) 'Add a column and a row
        Else
            ReDim Preserve ArrayToAddTo(UBound(ArrayToAddTo, 1), UBound(ArrayToAddTo, 2) + 1) 'Add a row
        End If
        '
        ' Now itterate through the fileds collection and add each cells value
        '
        For intFieldNdx = 0 To intFields
            ArrayToAddTo(intFieldNdx, UBound(ArrayToAddTo, 2)) = RowsToAdd(intFieldNdx, intRowNdx)
        Next intFieldNdx
    Next intRowNdx
    AddRecords = True
    Exit Function
ErrorHandler:
    Err.Raise Err.Number, "AddRecords", Err.Description
    
End Function
Public Function GetARecord(ByRef PassedArray As Variant, ByVal RecordNumber As Integer) As Variant
    '
    'This Function retrieves a single record form the array passed.
    '
    Dim intFieldNdx         As Integer  'A loop index to hold the current field
    Dim intNbrOfFields      As Integer  'Total number of fields in PassedArray
    Dim aryTemp()           As Variant  'A temporay Array that holds the results
    '
    On Error GoTo ErrorHandler
    '
    'Make sure we have a vaild array
    '
    If Not IsRealArray(PassedArray) Then
        Err.Raise -1234, "", "Passed Array is not a valid array."
    End If
    '
    ' Get the total number of fields
    '
    intNbrOfFields = UBound(PassedArray, 1)
    '
    ' Set up the resulting recordset
    '
    ReDim aryTemp(intNbrOfFields, 0)
    '
    'Logic: Cycle through each field and write the fields value to the temp array. Work directly on the record
    'Number that was passed. When the last field has been written, pass the temp array back as the result.
    '
    For intFieldNdx = 0 To intNbrOfFields
        aryTemp(intFieldNdx, 0) = PassedArray(intFieldNdx, RecordNumber)
    Next intFieldNdx
    GetARecord = aryTemp
    Exit Function

ErrorHandler:
    Err.Raise Err.Number, "GetARecord", Err.Description

End Function
Public Function GetRecordsByFieldValue(ByRef PassedArray, ByField As Integer, ByVal Value As Variant) As Variant
    '
    'Will return an Array that contains all rows that have matched a critera.
    'Critera are ByField and Value. ByField is the column/field to search (integer)
    'Value is the specific value to match. When a value in that colum matches the entire row is returned and
    'then the next row is scaned,
    'An array of subselected rows is returned.
    '
    Dim intRecordNdx    As Integer  'The current record
    Dim intNbrOfFields  As Integer  'Number of fields in passed Array
    Dim intNbrOfRecords As Integer  'Number of Records in Passed Array
    Dim aryTemp()       As Variant  'a Temp array to hold one recordset
    Dim aryResult()     As Variant  'The resulting recordset that is a collection of records
    '
    On Error GoTo ErrorHandler
    '
    ' Check to see if we are given a valid array
    '
    If Not IsRealArray(PassedArray) Then
        Err.Raise -1234, "", "Passed array is not a valid array."
    End If
    '
    'Get the Dimentions of the passed array
    '
    intNbrOfFields = UBound(PassedArray, 1)
    intNbrOfRecords = UBound(PassedArray, 2)
    '
    ' Logic: Itterate through each record. Compare the field value of the current record to what was passed.
    ' If they match then add that row to the results array. IF they don't match then move to the next record.
    ' Return the results array.
    '
    For intRecordNdx = 0 To intNbrOfRecords
        If PassedArray(ByField, intRecordNdx) = Value Then
            aryTemp = GetARecord(PassedArray, intRecordNdx)
            AddRecords aryResult(), aryTemp()
        End If
    Next intRecordNdx
    
    GetRecordsByFieldValue = aryResult
    Exit Function
ErrorHandler:
    Err.Raise Err.Number, "GetRecordsByFieldValue", Err.Description
    
End Function
Public Function IsThisRecordADuplicate(PassedArray() As Variant, Record() As Variant) As Boolean
    '
    'This Function is passed two arrays. It inspects the passed array for the presents of the Record array.
    'it is found then return true
    '
    Dim intRecordNdx        As Integer      'The current Record
    Dim intFieldNdx         As Integer      'The current Field
    Dim intNbrOfFields      As Integer      'Number of fields in the Passed Array
    Dim intNbrOfRecords     As Integer      'Number of records in the passed array
    Dim blnFieldMatch       As Boolean      'Feild level match flag
    '
    On Error GoTo ErrorHandler
    '
    '
    '
    If Not IsRealArray(PassedArray) Or Not IsRealArray(Record) Then
        Err.Raise -1234, "", "Passed Array and/or Record were invalid arrays."
    End If
    '
    ' Now get the sizes of passed array
    '
    intNbrOfFields = UBound(PassedArray, 1)
    intNbrOfRecords = UBound(PassedArray, 2)
    '
    'Logic: Cycle through each record in Passed Array. With the current record compare each field to each field
    'in the array record. If a total match is found then return a ture. Otherwise move to the next
    'Passed Array record and do the same.
    '
    For intRecordNdx = 0 To intNbrOfRecords
        For intFieldNdx = 0 To intNbrOfFields
            If PassedArray(intFieldNdx, intRecordNdx) = Record(intFieldNdx, 0) Then
                blnFieldMatch = True
            Else
                blnFieldMatch = False
                Exit For ' Bail out because as soon as one field fails the whole record should as well
            End If
         Next intFieldNdx
        '
        ' If we get here we have searched all of the fields if there was a match lets flag it
        '
        If blnFieldMatch Then
            IsThisRecordADuplicate = True
            Exit Function
        End If
    Next intRecordNdx
    'If we get here then this is not a dupe
    IsThisRecordADuplicate = False
    Exit Function
ErrorHandler:
    Err.Raise Err.Number, "IsThisRecordADuplicate", Err.Description
    End Function
Public Function AppendField(ByRef PassedArray() As Variant, ByVal DefaultFieldValue As Variant) As Variant()
    '
    'This function will append a field to the array that is passed. It also uses the defalut value that is
    'passed as the value for the newly created cell.
    '
    Dim intRecordNdx        As Integer  'The Current Record being used
    Dim intFieldNdx         As Integer  'The Current field
    Dim intNbrOfFields      As Integer  'Number of fields in passed array
    Dim intNbrOfRecords     As Integer  'Number of records in passed array
    Dim aryTemp()           As Variant  'A temporay array that will be the resulting array
    '
    On Error GoTo ErrorHandler
    '
    '
    '
    If Not IsRealArray(PassedArray) Then
        Err.Raise -1234, "", "Passed Array is not a valid array."
    End If
    '
    'Now get passed arrays sizes
    '
    intNbrOfFields = UBound(PassedArray, 1)
    intNbrOfRecords = UBound(PassedArray, 2)
    '
    'Redim the Temp array to be the number of records and the number of fields +1
    '
    ReDim aryTemp(intNbrOfFields + 1, intNbrOfRecords)
    '
    ' Logic: Itterate through the records of passed array down to the field level. Make an exact copy of the
    ' record. Then add the defalut value to temp arrays last element. Pass Temp array back as the result.
    '
    For intRecordNdx = 0 To intNbrOfRecords
        For intFieldNdx = 0 To intNbrOfFields
            aryTemp(intFieldNdx, intRecordNdx) = PassedArray(intFieldNdx, intRecordNdx)
        Next intFieldNdx
        '
        'Now append the default value to the end of the fields
        '
        aryTemp(intFieldNdx, intRecordNdx) = DefaultFieldValue
    Next intRecordNdx
    AppendField = aryTemp
    Exit Function
ErrorHandler:
    Err.Raise Err.Number, "AppendField", Err.Description
    
End Function
Public Function ConvertFieldDataToType(PassedArray() As Variant, FieldToChange As Integer, TypeToChangeTo As String) As Variant()
    '
    ' This function will convert a field in the passed array to the type specified. The result is an array
    ' with the field requested changed to what was asked.
    '
    Dim intRecordNdx        As Integer  'Loop index that holds the current record ID
    Dim intFieldNdx         As Integer  'Loop index that holds the current field ID
    Dim intNbrOfFields      As Integer  'The number of fields in the Passed Array
    Dim intNbrOfRecords     As Integer  'The number of records in the Passed Array
    Dim aryTemp()           As Variant  'A temporay array that will hold the results
    '
    On Error GoTo ErrorHandler
    '
    'Make sure what was passed is cool
    '
    If Not IsRealArray(PassedArray) Then
        Err.Raise -1234, "", "Array Passed is not a valid array."
    End If
    '
    ' Get the sizes of Passed Array
    '
    intNbrOfFields = UBound(PassedArray, 1)
    intNbrOfRecords = UBound(PassedArray, 2)
    '
    'Set up the resulting array
    '
    ReDim aryTemp(intNbrOfFields, intNbrOfRecords)
    '
    ' Logic, make an exact copy of the recordset down to the field level, but before a field is updated.
    ' check to make sure it is not the field to be converted. If if is then Convert it based on the type the
    ' user passed. Otherwise just copy the field. Return the tempory array.
    '
    For intRecordNdx = 0 To intNbrOfRecords
        For intFieldNdx = 0 To intNbrOfFields
            If intFieldNdx <> FieldToChange Then
                aryTemp(intFieldNdx, intRecordNdx) = PassedArray(intFieldNdx, intRecordNdx)
            Else
                Select Case UCase(TypeToChangeTo)
                    Case Is = "STRING"
                        aryTemp(intFieldNdx, intRecordNdx) = CStr(PassedArray(intFieldNdx, intRecordNdx))
                    Case Is = "INTEGER"
                        aryTemp(intFieldNdx, intRecordNdx) = CInt(PassedArray(intFieldNdx, intRecordNdx))
                    Case Is = "DATE"
                        aryTemp(intFieldNdx, intRecordNdx) = CDate(PassedArray(intFieldNdx, intRecordNdx))
                    '
                    ' More case statements can be added here to convert to other data types
                    '
                    Case Else
                        'Case else might want to throw an error?
                End Select
            End If
        Next intFieldNdx
    Next intRecordNdx
    ConvertFieldDataToType = aryTemp
    Exit Function
ErrorHandler:
    Err.Raise Err.Number, "ConvertFieldDataToType", Err.Description
End Function
Public Sub SaveArray(PassedArray As Variant, SavePath As String)
    '
    'This Sub is passed an array and a path with file name and extention. This Sub will then take
    'the passed array and write it out to the path/filename/extention passed.
    '
    Dim intRecordNdx    As Integer  'Current Record
    Dim intFieldNdx     As Integer  'Current field
    Dim intNbrOfFields  As Integer  'Total number of fields passed in passed array
    Dim intNbrOfRecords As Integer  'Total number of records passed in the passed array
    Dim strRow          As String   'A string of concatenated fields to make a row
    '
    On Error GoTo ErrorHandler
    '
    '
    '
    If Not IsRealArray(PassedArray) Then
        Err.Raise -1234, "", "Passed Array is not a valid array."
    End If
    '
    ' Now open the Path/Filename/extention
    '
    Open SavePath For Append As #1 'Append will create the file if it does not exist
    '
    ' Get the dimentions of the passed array
    '
    intNbrOfFields = UBound(PassedArray, 1)
    intNbrOfRecords = UBound(PassedArray, 2)
    '
    ' Logic: Buid a string that contains each recoords field values. Once each field for the current record
    ' has been added to the string write the string to the file. Close the file after all records have been
    ' processed.
    '
    For intRecordNdx = 0 To intNbrOfRecords
        For intFieldNdx = 0 To intNbrOfFields
            If strRow = "" Then
                strRow = PassedArray(intFieldNdx, intRecordNdx)
            Else
                strRow = strRow & "," & PassedArray(intFieldNdx, intRecordNdx)
            End If
        Next intFieldNdx
        Print #1, strRow
        strRow = ""
    Next intRecordNdx
    Close #1
    Exit Sub
ErrorHandler:
    Err.Raise Err.Number, "SaveArray", Err.Description
End Sub
Public Function RemoveFields(PassedArray() As Variant, FieldsToRemove() As Variant) As Variant()
    'This function will be passed an array that has the same format as an array created by
    'the recordset.getrows command. It is also passed an array of fields that are to be removed.
    'This array is created using the function array(1,2,3,...x). This Function will return an array
    'that is the is identical to the passed array with the exception of the removed fields
    Dim intRecordNdx            As Integer  'Current Record
    Dim intFieldNdx             As Integer  'Current field
    Dim intNbrOfFields          As Integer  'Total number of fields passed in passed array
    Dim intNbrOfRecords         As Integer  'Total number of records passed in the passed array
    Dim intNbrOfFieldsToRemove  As Integer  'Total count of fields to be removed
    Dim intRemoveNdx            As Integer  'The current index of the field being removed
    Dim blnSkipThis             As Boolean  'A flag that tells us to skip this field
    Dim artResult()             As Variant  'A temp array that will hold the results
    Dim intNewFieldIndex        As Integer
    '
    On Error GoTo ErrorHandler
    '
    'Check what was passed to verify that it is a real array
    '
    If Not IsRealArray(PassedArray) Then
        Err.Raise -1234, "", "Passed array is not a vaild array."
    End If
    '
    ' Get the size of what was passed
    '
    intNbrOfFields = UBound(PassedArray, 1)
    intNbrOfRecords = UBound(PassedArray, 2)
    intNbrOfFieldsToRemove = UBound(FieldsToRemove)
    '
    'Now set up the resulting array
    '
    ReDim aryResult(intNbrOfFields - (intNbrOfFieldsToRemove + 1), intNbrOfRecords)
    '
    'Logic, Itterate through the PassedArray to the field level. Check the current fields position
    'if it is in the fields to be removed array skip this field and move to the next field. If it
    'was not found in the Fields to be removed array then add this records current field to the
    'result array. Once all fields for the record have been processed, move to the next record and
    'do the same thing. Once all the records have been processed, return the result array.
    '
    For intFieldNdx = 0 To intNbrOfFields
        'Check each of the Remove arrays values to see if this field is there
        For intRemoveNdx = 0 To intNbrOfFieldsToRemove
            If FieldsToRemove(intRemoveNdx) = intFieldNdx Then
                blnSkipThis = True
                Exit For
            End If
        Next intRemoveNdx
        '
        'We just checked all of the remove index, now lets see if the flag was ever thrown
        '
        If blnSkipThis Then
            blnSkipThis = False 'Reset the flag and move to the next field
        Else 'We are not skiping this one so add it to the result array
            'Itterate through all of the records
            For intRecordNdx = 0 To intNbrOfRecords
                aryResult(intNewFieldIndex, intRecordNdx) = PassedArray(intFieldNdx, intRecordNdx)
            Next intRecordNdx
            'Now increment the newfield index for the next go round
            intNewFieldIndex = intNewFieldIndex + 1
        End If
    Next intFieldNdx
    
    RemoveFields = aryResult
    Exit Function
ErrorHandler:
    Err.Raise Err.Number, "RemoveFields", Err.Description
End Function
Public Function IsRealArray(ByVal vArray As Variant) As Boolean

    Dim i As Integer
    On Error GoTo ErrorHandler
    IsRealArray = True
    i = UBound(vArray, 1)
    
    Exit Function
    
ErrorHandler:
    If Err.Number = 9 Then
        IsRealArray = False
        Err.Clear
    ElseIf Err.Number = 13 Then
        IsRealArray = False
        Err.Clear
    Else
        Err.Raise Err.Number
    End If
    
End Function

Public Function StripDupes(ByRef PassedArray() As Variant) As Boolean
    'This function will be handed an array and it will compare each record with the next record.
    'If a Dupe is found the current record will be removed.
    Dim intRecordNdx            As Integer  'Current Record
    Dim intFieldNdx             As Integer  'Current field
    Dim intNbrOfFields          As Integer  'Total number of fields passed in passed array
    Dim intNbrOfRecords         As Integer  'Total number of records passed in the passed array
    Dim intNbrOfFieldsToRemove  As Integer  'Total count of fields to be removed
    Dim intRemoveNdx            As Integer  'The current index of the field being removed
    Dim blnDupRecord            As Boolean  'A flag that tells us this record is a dupe!
    Dim blnDupField             As Boolean  'A flag to tell us that this field is a dupe
    Dim aryResult()             As Variant  'An Array to hold the results
    Dim aryTemp()               As Variant  'Temp array to hold results of getonerow
    Dim intNextRecord           As Integer  'Loop index for the remainding set of records to check
    intNbrOfRecords = UBound(PassedArray, 2)
    intNbrOfFields = UBound(PassedArray, 1)
    
    For intRecordNdx = 0 To intNbrOfRecords
        For intNextRecord = intRecordNdx + 1 To intNbrOfRecords 'Minus one because we won't compare the last value to anything
            For intFieldNdx = 0 To intNbrOfFields
                If PassedArray(intFieldNdx, intRecordNdx) = PassedArray(intFieldNdx, intNextRecord) Then
                    blnDupField = True
                Else 'If the field does not match then move on to the next record!
                    blnDupField = False
                    Exit For 'Exit checking for the next field
                End If
            Next intFieldNdx
            '
            If Not blnDupField Then 'We just went through all of the fields
                    'And did not have a match, so add this record to the result
                aryTemp = GetARecord(PassedArray, intRecordNdx)
                AddRecords aryResult, aryTemp
            Else 'This was a dupe so don't add it!
            End If
            blnDupField = False
        Next intNextRecord
    Next intRecordNdx
PassedArray = aryResult
StripDupes = True
End Function


